<%@ Page Language="c#" %>
<%@ Register TagPrefix="uc1" TagName="SiteTop" Src="SiteTop.ascx" %>
<%@ Register TagPrefix="uc1" TagName="SiteBottom" Src="SiteBottom.ascx" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>Manager</title>
		<link rel='stylesheet' href='SiteStyle.css'>
	</HEAD>
	<body>
		<form id="Form1" method="post" runat="server">
			<uc1:SiteTop id="SiteTop1" runat="server"></uc1:SiteTop>
			<table cellSpacing="0" cellPadding="0" class="Container" align="center" border="0">
				<tr>
					<td width="10" nowrap></td>					
					<td width="100%" valign="top" height="400">		
						<h3>Manage Operators</h3>
						<asp:DataGrid Runat="server" id="DataGrid1" BorderColor="#CCCCCC" BorderStyle="None" BorderWidth="1px"
							BackColor="White" CellPadding="3" AutoGenerateColumns="False" Width="500px" AllowPaging="True"
							DataKeyField="LoginName">
							<FooterStyle ForeColor="#000066" BackColor="White"></FooterStyle>
							<SelectedItemStyle Font-Bold="True" BackColor="#999999"></SelectedItemStyle>
							<HeaderStyle Font-Bold="True" BackColor="#eeeeee"></HeaderStyle>
							<Columns>
								<asp:BoundColumn DataField="LoginName" HeaderText="LoginName"></asp:BoundColumn>
								<asp:BoundColumn DataField="NickName" HeaderText="NickName"></asp:BoundColumn>
								<asp:BoundColumn DataField="Password" HeaderText="Password"></asp:BoundColumn>
								<asp:ButtonColumn Text="Delete" CommandName="Delete"></asp:ButtonColumn>
							</Columns>
							<PagerStyle HorizontalAlign="Left" ForeColor="#000066" BackColor="White" Mode="NumericPages"></PagerStyle>
						</asp:DataGrid>
						<br>
						<br>
						<table cellspacing="1" cellpadding="5" border="0" style="BACKGROUND-COLOR: #cccccc" width="500">
							<tr>
								<td valign="top" class="boxTitle" height="30">
									Create Operators
								</td>
							</tr>
							<tr>
								<td valign="top" class="boxArea">
									<table width="100%" cellspacing="1" cellpadding="3" border="0" align="center">
										<tr>
											<td nowrap class="FieldName">UserName:</td>
											<td>
												<asp:textbox id="UsernameBox" Width="200px" runat="server" TextMode="SingleLine" />
												<asp:RequiredFieldValidator id="RequiredFieldValidator1" runat="server" ErrorMessage="Username is required"
													ControlToValidate="UsernameBox" Display="Dynamic"></asp:RequiredFieldValidator>
												<asp:RegularExpressionValidator runat="server" ControlToValidate="UsernameBox" ErrorMessage="Please keep Username one word with no spaces or special characters."
													ValidationExpression="^[a-zA-Z0-9\._-]+$" ID="Regularexpressionvalidator1"></asp:RegularExpressionValidator>
											</td>
										</tr>
										<tr>
											<td nowrap class="FieldName">Password:</td>
											<td><asp:textbox id="PasswordBox" Width="200px" textmode="Password" runat="server" />
												<asp:RequiredFieldValidator id="RequiredFieldValidator2" runat="server" ErrorMessage="Password is required."
													ControlToValidate="PasswordBox" Display="Dynamic"></asp:RequiredFieldValidator>
											</td>
										</tr>
										<TR>
											<td nowrap class="FieldName">Department:</td>
											<TD><asp:DropDownList Width="200px" Runat="server" ID="DepartmentBox"></asp:DropDownList></TD>
										</TR>
										<tr>
											<td>&nbsp;</td>
											<td>
												<asp:LinkButton Runat="server" ID="RegisterButton" Text="Create" />
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						<asp:Label id="MessageLabel" runat="server" ForeColor="Maroon" Visible="False" EnableViewState="False">Label</asp:Label>
						<br>
						<br>
					</td>
					<td width="10" nowrap></td>
				</tr>
			</table>
			<uc1:sitebottom id="SiteBottom1" runat="server"></uc1:sitebottom>
		</form>
		<script runat="server">

override protected void OnInit(EventArgs e)
{
	//
	// CODEGEN: This call is required by the ASP.NET Web Form Designer.
	//
	InitializeComponent();
	base.OnInit(e);
}

/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
private void InitializeComponent()
{    
	this.DataGrid1.DataBinding += new System.EventHandler(this.DataGrid1_DataBinding);
	this.DataGrid1.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_DeleteCommand);
	this.DataGrid1.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.DataGrid1_PageIndexChanged);
	this.RegisterButton.Click += new System.EventHandler(this.RegisterButton_Click);
}

protected override void OnLoad(EventArgs e)
{
	CuteChat.AppChatIdentity identity=CuteChat.ChatProvider.Instance.GetLogonIdentity();
	if(identity==null)
	{
		Response.Redirect("Login.aspx",true);
		return;
	}
	if(!CuteChat.ChatProvider.Instance.IsAdministrator(identity.UniqueId))
	{
		Response.Redirect("Login.aspx",true);
		return;
	}

	base.OnLoad (e);

	if(!IsPostBack)
	{
	
		CuteChat.ChatWebUtility.SetupAdministratorAgent(identity.UniqueId);
		
		DataGrid1.DataBind();

		DepartmentBox.DataSource=CuteChat.ChatWebUtility.LoadDepartments();
		DepartmentBox.DataTextField="Name";
		DepartmentBox.DataValueField="Name";
		DepartmentBox.DataBind();
	}
}


private void DataGrid1_DataBinding(object sender, System.EventArgs e)
{
	DataGrid1.DataSource=GlobalAsax.ExampleProvider.LoadUsers();
}

private void DataGrid1_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
{
	string loginName=(string)DataGrid1.DataKeys[e.Item.ItemIndex];
	GlobalAsax.ExampleProvider.DeleteUser(loginName);

	DataGrid1.DataBind();
}

private void DataGrid1_PageIndexChanged(object source,System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
{
	DataGrid1.CurrentPageIndex=e.NewPageIndex;
	DataGrid1.DataBind();
}


private void RegisterButton_Click(object sender, System.EventArgs e)
{
	if(!Page.IsValid)return;

	string username=UsernameBox.Text.Trim();
	string password=PasswordBox.Text;

	string nickname=null;
	string dbpassword=null;
	bool isAdmin=false;
	bool userexists=GlobalAsax.ExampleProvider.GetUserInfo(username,ref nickname,ref dbpassword,ref isAdmin);

	if(userexists)
	{
		MessageLabel.Text="The username you entered is already being used.";
		MessageLabel.Visible=true;
		return;
	}
	if(DepartmentBox.SelectedIndex==-1)
	{
		MessageLabel.Text="No department selected! Please manage the departments.";
		MessageLabel.Visible=true;
		return;
	}
	string deptname=DepartmentBox.SelectedValue;

	GlobalAsax.ExampleProvider.CreateUser(username,username,password);

	CuteChat.ChatWebUtility.AddAgent(deptname,CuteChat.ChatProvider.Instance.ToUserId(username));
	
	//Response.Redirect("~/");
	MsgBox("User Created!");
	UsernameBox.Text="";
	PasswordBox.Text="";
	DataGrid1.DataBind();

}

public static void MsgBox(String msg)
{
	System.Web.HttpContext.Current.Response.Write("<script language='javascript'>alert('" + msg + "');</scr"+"ipt>");
}


		</script>
	</body>
</HTML>
